<template>
  <div class="wp-12 wp-layout wp-layout--no-pad wp-layout--form">
    <div class="wp-12 wp-layout wp-layout--no-pad">
      <wp-input class="wp-12" type="text" v-model="reason.name"
        label="Название причины" placeholder="Введите название"/>
    </div>
    <div class="wp-12 wp-layout wp-layout--no-pad">
      <button class="wp-button wp-button--margin-right" @click="submit">
        Сохранить изменения
      </button>
      <button class="wp-button wp-button--cancel" @click="$emit('close')">
        Отменить
      </button>
    </div>
  </div>
</template>

<script>
import { mapActions } from 'vuex';

import WpInput from '@/components/WpInput.vue';

export default {
  name: 'Reason',
  components: {
    WpInput,
  },
  data() {
    return {
      reason: {
        name: '',
      },
    };
  },
  props: {
    data: {
      type: Object,
      default: () => undefined,
    },
  },
  methods: {
    ...mapActions('organization', ['createReason', 'updateReason']),
    submit() {
      if (this.$props.data) {
        this.editReason();
      } else {
        this.addReason();
      }
    },
    async addReason() {
      try {
        await this.createReason(this.reason);
        this.$toasted.success('Причина создана');
        this.$emit('close');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
    async editReason() {
      try {
        await this.updateReason(this.reason);
        this.$toasted.success('Причина изменена');
        this.$emit('close');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
  },
  created() {
    if (this.$props.data) {
      this.reason = Object.assign({}, this.$props.data);
    }
  },
};
</script>

<style></style>
